#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include "kahn.h"

void *integers(void *arg) {
  struct channel *qo = (struct channel *)arg;
  int n = 1;
  while (1) {
    n++;
    put(n, qo);
  }
  return NULL;
}

void *output(void *arg) {
  struct channel *qi = (struct channel *)arg;
  while (1) {
    printf("%d\n", get(qi));
    fflush(stdout);
  }
  return NULL;
}

void question1() {
  pthread_t p1;
  pthread_t p2;
  struct channel *q = new_channel();
  pthread_create(&p1, NULL, integers, q);
  pthread_create(&p2, NULL, output, q);
  pthread_detach(p1);
  pthread_detach(p2);
  pause();
}

/* ******************************************************************** */

struct proc_in {
  char *name;
  struct channel *qi;
  struct channel *qo;
};


void *proc1(void *arg) {
  struct proc_in *in = (struct proc_in *)arg;
  while (1) {
    printf("%s: PUT\n",in->name);
    put(1, in->qo);
    printf("%s: GET\n",in->name);
    get(in->qi);
  }
  return NULL;
}

void question4() {
  pthread_t p1;
  pthread_t p2;
  struct channel *q1 = new_channel();
  struct channel *q2 = new_channel();
  struct proc_in in_a;
  struct proc_in in_b;
  in_a.name = "A";
  in_a.qi = q1;
  in_a.qo = q2;
  in_b.name = "B";
  in_b.qi = q2;
  in_b.qo = q1;
  pthread_create(&p1, NULL, proc1, &in_a);
  pthread_create(&p2, NULL, proc1, &in_b);
  pthread_detach(p1);
  pthread_detach(p2);
  pause();
}

/* ******************************************************************** */

void *proc2(void *arg) {
  struct proc_in *in = (struct proc_in *)arg;
  while (1) {
    printf("%s: PUT\n",in->name);
    put(1, in->qo);
    printf("%s: PUT\n",in->name);
    put(1, in->qo);
    printf("%s: GET\n",in->name);
    get(in->qi);
    printf("%s: GET\n",in->name);
    get(in->qi);
  }
  return NULL;
}

void question5() {
  pthread_t p1;
  pthread_t p2;
  struct channel *q1 = new_channel();
  struct channel *q2 = new_channel();
  struct proc_in in_a;
  struct proc_in in_b;
  in_a.name = "A";
  in_a.qi = q1;
  in_a.qo = q2;
  in_b.name = "B";
  in_b.qi = q2;
  in_b.qo = q1;
  pthread_create(&p1, NULL, proc2, &in_a);
  pthread_create(&p2, NULL, proc2, &in_b);
  pthread_detach(p1);
  pthread_detach(p2);
  pause();
}

/* ******************************************************************** */

struct filter_input {
  int prime;
  struct channel *qi;
  struct channel *qo;
};

void *filter(void *arg) {
  struct filter_input *in = (struct filter_input *) arg;
  int prime = in->prime;
  int n;
  while (1) {
    n = get(in->qi);
    if ( (n % prime) != 0 ) {
      put(n, in->qo);
    }
  }
  return NULL;
}

void *sift(void *arg) {
  struct channel *qi = ((struct channel **) arg)[0];
  struct channel *qo = ((struct channel **) arg)[1];
  int prime = get(qi);
  put(prime, qo);
  {
    pthread_t p1;
    pthread_t p2;
    struct channel *q = new_channel();
    struct filter_input *filter_in;
    struct channel **sift_in;
    filter_in = (struct filter_input*) malloc(sizeof(struct filter_input));
    filter_in->prime = prime;
    filter_in->qi = qi;
    filter_in->qo = q;
    sift_in = (struct channel**) malloc(2*sizeof(struct channel*));
    sift_in[0] = q;
    sift_in[1] = qo;
    pthread_create(&p1, NULL, filter, filter_in);
    pthread_create(&p2, NULL, sift, sift_in);
    pthread_detach(p1);
    pthread_detach(p2);
    return NULL;
  }
}


void crible() {
  pthread_t p1;
  pthread_t p2;
  pthread_t p3;
  struct channel *q[2];
  q[0] = new_channel();
  q[1] = new_channel();
  pthread_create(&p1, NULL, integers, q[0]);
  pthread_create(&p2, NULL, sift, q);
  pthread_create(&p3, NULL, output, q[1]);
  pthread_detach(p1);
  pthread_detach(p2);
  pthread_detach(p3);
  pause();
}


/* ******************************************************************** */

int main() {
  // question1();
  // question4();
  // question5();
  crible();
  return 0;
}
