#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

struct channel {
  pthread_mutex_t vide;
  pthread_mutex_t plein;
  int buffer;
};

struct channel *new_channel() {
  struct channel *chan = (struct channel *) malloc(sizeof(struct channel));
  if ( NULL == chan ) { return NULL; }
  pthread_mutex_init(&(chan->vide), NULL);
  pthread_mutex_init(&(chan->plein), NULL);
  pthread_mutex_lock(&(chan->plein));
  return chan;
}

void put(int n, struct channel *chan) {
  pthread_mutex_lock(&(chan->vide));
  chan->buffer = n;
  pthread_mutex_unlock(&(chan->plein));
  return ;
}

int get(struct channel *chan) {
  int res;
  pthread_mutex_lock(&(chan->plein));
  res = chan->buffer;
  pthread_mutex_unlock(&(chan->vide));
  return res;
}
