#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>

#define N 10

struct channel {
  sem_t vide;
  sem_t plein;
  int buffer[N];
  int libre;
  int prochain;
};

struct channel *new_channel() {
  struct channel *chan = (struct channel *) malloc(sizeof(struct channel));
  chan->libre = 0;
  chan->prochain = 0;
  sem_init(&(chan->vide), 0, N); 
  sem_init(&(chan->plein), 0, 0); 
  return chan;
}

void put(int n, struct channel *chan) {
  sem_wait(&(chan->vide)); 
  chan->buffer[chan->libre] = n; 
  chan->libre = (chan->libre + 1) % N; 
  sem_post(&(chan->plein)); 
  return ;
}

int get(struct channel *chan) {
  int res;
  sem_wait(&(chan->plein)); 
  res = chan->buffer[chan->prochain]; 
  chan->prochain = (chan->prochain + 1) % N; 
  sem_post(&(chan->vide));
  return res;
}
